*--------------------------------------------------------------*;
*--- PSI17 DIAGNOSIS AND PROCEDURE MACROS V6.0.2 ICD-09-CM ---*;
*--- VERSION DATE AUGUST 2017                               ---*;
*--------------------------------------------------------------*;
 
 /*-- Macro MDX searches entire DX vector for presence    --*/
 /*-- of diagnosis codes present in format passed (&FMT). --*/
 %MACRO MDX(FMT);

 (%DO I = 1 %TO &NDX.-1;
  (put(DX&I.,&FMT.) = '1') or
  %END;
  (put(DX&NDX.,&FMT.) = '1'))

 %MEND;

 /*-- Macro MDX1 searches ONLY first diagnosis code for    --*/
 /*-- presence of diagnosis codes in format passed (&FMT). --*/
 %MACRO MDX1(FMT);

 (put(DX1,&FMT.) = '1')

 %MEND;

 /*-- Macro MDX2 searches secondary diagnosis codes for  --*/
 /*-- presence of diagnosis codes in format passed       --*/
 %MACRO MDX2(FMT);

 (%DO I = 2 %TO &NDX.-1;
  (put(DX&I.,&FMT.) = '1') or
  %END;
  (put(DX&NDX.,&FMT.) = '1'))

 %MEND;


/*-- Macro Defsite used in remapping MDC --*/
%macro defsite;
 %do i = 1 %to &ndx.;
        if put(dx&i.,$s1FMT.)='1' then site_dx&i.='he';
   else if put(dx&i.,$s2FMT.)='1' then site_dx&i.='ch';
   else if put(dx&i.,$s3FMT.)='1' then site_dx&i.='ab';
   else if put(dx&i.,$s4FMT.)='1' then site_dx&i.='ki';
   else if put(dx&i.,$s5FMT.)='1' then site_dx&i.='ur';
   else if put(dx&i.,$s6FMT.)='1' then site_dx&i.='ps';
   else if put(dx&i.,$s7FMT.)='1' then site_dx&i.='ul';
   else if put(dx&i.,$s8FMT.)='1' then site_dx&i.='ll';
   else site_dx&i.=' ';
 %end;
 %mend defsite;
